<template>
<section class="section">
    <div class="container">
    
        <articleItem v-for="article in articlesData" :key="article.id" :article="article"></articleItem>

        <b-pagination
            :total="pgTotal"
            :current="pgCurrent"
            :order="paging.order"
            :size="paging.size"
            :simple="paging.isSimple"
            :per-page="pgPerPage"
            @change="pageChanged">
        </b-pagination>

    </div>
</section>
</template>

<script>
import { mapState } from 'vuex'

import ArticleItem from '~components/ArticleItem.vue'

export default {
    validate ({ params }) {
        return !isNaN(+params.page)
    },
    async asyncData ({ params, error, store, redirect }) {
        if (params.page == 1) redirect('/blog')
        await store.dispatch('FETCH_ARTICLES', { page: Number(params.page) })
        if (store.state.articles.data.length < 1) {
            return error({ message: 'User not found', statusCode: 404 })
        }
        return
    },
    components: {
        ArticleItem
    },
    data() {
        return {
            paging: {
                order: '',
                size: '',
                isSimple: false
            }
        }
    },
    computed: mapState({
        articlesData: (state) => state.articles.data,
        pgTotal: (state) => state.articles.total,
        pgPerPage: (state) => state.articles.limit,
        pgCurrent: (state) => state.articles.currentPage
    }),
    methods: {
        pageChanged(value) {
            this.$router.push('/blog/'+value)
        }
    }
}
</script>